/*
	PROforma, PROgs FOnt & Raster MAnager

	drawing routines for mode 33 bitmap driver
	CopyArea function, to copy a part of the bitmap

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 9 November 1999
*/

#include "PFmodule.h"

Error CopyArea(Bitmap from, Bitmap to, short xsiz, short ysiz,
			   short fromx, short fromy, short tox, short toy)
{
	unsigned char *obuff, *dbuff;
	int i, j;
	int oinc=from->linc;
	int dinc=  to->linc;

	if (fromy<toy)
	{
		fromy+=ysiz-1;
		toy+=ysiz-1;
		oinc=-oinc;
		dinc=-dinc;
	}
	if (fromx<tox)
	{
		fromx+=xsiz-1;
		tox+=xsiz-1;
	}

	obuff=from->base+fromy*from->linc+fromx*2;
	dbuff=	to->base+  toy*  to->linc+	tox*2;

	if (fromx<tox)
	{
		for (i=ysiz ; i ; i--)
		{
			unsigned short *ob=(unsigned short *)obuff;
			unsigned short *db=(unsigned short *)dbuff;
			for (j=xsiz ; j ; j--) *db--=*ob--;
			obuff+=oinc;
			dbuff+=dinc;
		}
	} else {
		for (i=ysiz ; i ; i--)
		{
			unsigned short *ob=(unsigned short *)obuff;
			unsigned short *db=(unsigned short *)dbuff;
			for (j=xsiz ; j ; j--) *db++=*ob++;
			obuff+=oinc;
			dbuff+=dinc;
		}
	}

	return ERR_OK;
}
