; PROforma, PROgs Font & Raster Manager
;
; routine to draw a mask in black in a mode4 bitmap
;
; (c) PROGS, Professional & Graphical Software
; written by Joachim Van der Auwera
; started 05 October 1995
;
    include win1_pf_bitm_bitmap_in
    include win1_inc_keys_err
    include win1_inc_aid_mac
    section text
;
bitmap  equ  0+32   .l
mask    equ  4+32   .l
xpos    equ  8+32   .w
ypos    equ 10+32   .w
; register usage (compared with c code)
;   a0  mbase               d0  scratch
;   a1  rbase               d1  scratch
;   a2  bitmap              d2  nrlines
;   a3  mask                d3  xpos, rshift
;   a4  rlinestart          d4  ypos, lshift
;   a5                      d5  i
_BlackDrawMask xsub
    regsave d2-d5/a2-a4

    move.l  bitmap(sp),a2
    move.l  mask(sp),a3
    move.w  xpos(sp),d3
    move.w  ypos(sp),d4
    bmi.s   cliptest            ; partly invisible !
    tst.w   d3
    bmi.s   cliptest            ; partly invisible !

    ; perform clipping (partly)
    move.w  b_clip_xsiz(a2),d0
    sub.w   m_xsiz(a3),d0
    cmp.w   d0,d3
    bgt.s   cliptest            ; right border too far
    move.w  b_clip_ysiz(a2),d0
    sub.w   m_ysiz(a3),d0
    cmp.w   d0,d4
    ble.s   noclip              ; right border too far

    ; is the mask completely invisible ?
cliptest
    cmp.w   b_clip_xsiz(a2),d3
    bge     done
    cmp.w   b_clip_ysiz(a2),d4
    bge     done
    move.w  d3,d0
    add.w   m_xsiz(a3),d0
    ble     done
    move.w  d4,d0
    add.w   m_ysiz(a3),d0
    ble     done

    ; partly invisible - call specialised routine
    move.w  d4,-(sp)
    move.w  d3,-(sp)
    move.l  a3,-(sp)
    move.l  a2,-(sp)
    jsr     MaskClipped
    adda.w  #12,sp
    bra.s   exit

    ; actually draw the mask
noclip
    add.w   b_clip_xpos(a2),d3
    add.w   b_clip_ypos(a2),d4

    move.w  b_linc(a2),d0       ; calculate rlinestart
    mulu    d4,d0
    add.l   b_base(a2),d0
    move.l  d0,a4
    move.w  d3,d0
    lsr.w   #2,d0
    bclr    #0,d0
    adda.w  d0,a4

    lea     m_mask(a3),a1       ; rbase
    move.w  m_ysiz(a3),d2       ; nr of lines in mask
    subq.w  #1,d2               ; adjust for dbf
    bmi.s   done

    and.w   #7,d3               ; rshift
    bne.s   fullblown

    ; no shifts necessary while drawing
line
    move.l  a4,a0
    move.w  m_linc(a3),d5       ; i=mask->linc
    subq.w  #1,d5               ; adjust for dbf
draw
    move.b  (a1)+,d1
    not.b   d1
    and.b   d1,(a0)+
    and.b   d1,(a0)+

    dbf     d5,draw

    adda.w  b_linc(a2),a4       ; rlinestart+=bitmap->linc
    dbf     d2,line
    bra.s   done

    ; full blown mask drawing - using both left and right shifts
fullblown
    moveq   #8,d4
    sub.w   d3,d4               ; lshift
linef
    move.l  a4,a0
    move.w  m_linc(a3),d5       ; i=mask->linc
    subq.w  #1,d5               ; adjust for dbf
drawf
    move.b  (a1)+,d0
    move.b  d0,d1
    lsr.b   d3,d0
    not.b   d0
    and.b   d0,(a0)+
    lsl.b   d4,d1
    and.b   d0,(a0)+
    not.b   d1
    and.b   d1,(a0)
    and.b   d1,1(a0)

    dbf     d5,drawf

    adda.w  b_linc(a2),a4       ; rlinestart+=bitmap->linc
    dbf     d2,linef
done
    moveq   #0,d0
exit
    subend


; following code comes from the compiled c code

MaskClipped
    link    a6,#-48
    movem.l d3/d4/d5/d6/d7/a2/a3/a4/a5,-(a7)
    move.l  8(a6),a2
    move.l  12(a6),a5
    move.w  2(a5),d0
    ext.l   d0
    move.l  d0,d6
    move.l  #6,d0
    add.l   a5,d0
    move.l  d0,a4
    tst.w   18(a6)
    bge.s I_34
    move.w  18(a6),d0
    ext.l   d0
    add.l   d0,d6
    tst.l   d6
    bgt.s I_35
I_70:
    move.l  #0,d0
    movem.l (a7)+,d3/d4/d5/d6/d7/a2/a3/a4/a5
    unlk    a6
    rts
I_35:
    move.w  4(a5),d0
    ext.l   d0
    move.l  d0,-(a7)
    move.w  18(a6),d0
    ext.l   d0
    neg.l   d0
    move.l  d0,-(a7)
    xjsr .Xlmul
    add.l   d0,a4
    clr.w   18(a6)
I_34:
    move.w  20(a2),d0
    ext.l   d0
    move.w  18(a6),d1
    ext.l   d1
    add.l   d6,d1
    cmp.l   d0,d1
    ble.s I_38
    move.w  18(a6),d0
    ext.l   d0
    add.l   d6,d0
    move.w  20(a2),d1
    ext.l   d1
    sub.l   d1,d0
    sub.l   d0,d6
    tst.l   d6
    ble I_70
I_38:
    move.w  22(a2),d0
    add.w   d0,16(a6)
    move.w  24(a2),d0
    add.w   d0,18(a6)
    move.w  16(a6),d0
    and.w   #7,d0
    ext.l   d0
    move.l  d0,-16(a6)
    move.w  4(a2),d0
    muls    18(a6),d0
    add.l   (a2),d0
    move.l  d0,a3
    move.w  22(a2),d0
    ext.l   d0
    move.l  d0,d5
    move.w  22(a2),d0
    ext.l   d0
    move.w  18(a2),d1
    ext.l   d1
    add.l   d1,d0
    move.l  d0,d7
    move.l  #255,d0
    move.l  #7,d1
    and.l   d5,d1
    asr.l   d1,d0
    not.l   d0
    move.l  d0,-28(a6)
    move.l  #255,d0
    move.l  #7,d1
    and.l   d7,d1
    asr.l   d1,d0
    move.l  d0,-32(a6)
    tst.l   d5
    blt.s I_39
    move.l  d5,d0
    lsr.l   #3,d0
    bra.s I_40
I_39:
    move.l  d5,d0
    neg.l   d0
    add.l   #7,d0
    lsr.l   #3,d0
    neg.l   d0
I_40:
    add.l   d0,d0
    move.l  d0,d5
    pea 8
    move.l  d7,-(a7)
    xjsr .Xldiv
    add.l   d0,d0
    move.l  d0,d7
    tst.w   16(a6)
    blt.s I_41
    move.w  16(a6),d0
    ext.l   d0
    lsr.l   #3,d0
    bra.s I_42
I_41:
    move.w  16(a6),d0
    ext.l   d0
    neg.l   d0
    add.l   #7,d0
    lsr.l   #3,d0
    neg.l   d0
I_42:
    add.l   d0,d0
    move.l  d0,-44(a6)
    tst.l   -16(a6)
    beq I_60
    move.l  #8,d0
    sub.l   -16(a6),d0
    move.l  d0,-20(a6)
    bra I_45
I_44:
    move.l  -44(a6),d3
    move.w  4(a5),-2(a6)
    bra.s I_49
I_48:
    clr.l   d0
    move.b  (a4),d0
    move.l  -16(a6),d1
    asr.l   d1,d0
    not.l   d0
    move.b  d0,d4
    cmp.l   d7,d3
    bne.s I_52
    move.b  -29(a6),d0
    or.b    d0,d4
I_52:
    cmp.l   d5,d3
    bne.s I_53
    move.b  -25(a6),d0
    or.b    d0,d4
I_53:
    cmp.l   d5,d3
    blt.s I_54
    cmp.l   d7,d3
    bgt.s I_54
    and.b   d4,0(a3,d3.l)
    move.l  a3,a0
    add.l   d3,a0
    and.b   d4,1(a0)
I_54:
    move.l  #2,d0
    add.l   d0,d3
    move.l  a4,a0
    add.w   #1,a4
    clr.l   d0
    move.b  (a0),d0
    move.l  -20(a6),d1
    asl.l   d1,d0
    not.l   d0
    move.b  d0,d4
    cmp.l   d7,d3
    bne.s I_55
    move.b  -29(a6),d0
    or.b    d0,d4
I_55:
    cmp.l   d5,d3
    bne.s I_56
    move.b  -25(a6),d0
    or.b    d0,d4
I_56:
    cmp.l   d5,d3
    blt.s I_57
    cmp.l   d7,d3
    bgt.s I_57
    and.b   d4,0(a3,d3.l)
    move.l  a3,a0
    add.l   d3,a0
    and.b   d4,1(a0)
I_57:
    sub.w   #1,-2(a6)
I_49:
    tst.w   -2(a6)
    bne I_48
    move.w  4(a2),d0
    add.w   d0,a3
    sub.l   #1,d6
I_45:
    tst.l   d6
    bne I_44
    bra I_70
I_59:
    move.l  -44(a6),d3
    move.w  4(a5),-2(a6)
    bra.s I_64
I_63:
    move.l  a4,a0
    add.w   #1,a4
    clr.l   d0
    move.b  (a0),d0
    not.l   d0
    move.b  d0,d4
    cmp.l   d7,d3
    bne.s I_67
    move.b  -29(a6),d0
    or.b    d0,d4
I_67:
    cmp.l   d5,d3
    bne.s I_68
    move.b  -25(a6),d0
    or.b    d0,d4
I_68:
    cmp.l   d5,d3
    blt.s I_69
    cmp.l   d7,d3
    bgt.s I_69
    and.b   d4,0(a3,d3.l)
    move.l  a3,a0
    add.l   d3,a0
    and.b   d4,1(a0)
I_69:
    sub.w   #1,-2(a6)
    move.l  #2,d0
    add.l   d0,d3
I_64:
    tst.w   -2(a6)
    bne I_63
    move.w  4(a2),d0
    add.w   d0,a3
    sub.l   #1,d6
I_60:
    tst.l   d6
    bne I_59
    bra I_70

;
    end
