/*
	PROforma, PROGS FOnt & Raster MAnager

	UniCode <-> ASCII conversions etc.

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 April 1995
	20.20.1995 PFASCII2UnicodeTable now has .undef for mpty chars (was \0)
*/

#include "gstate_h"

static short ASCII2unicode[256] =
{
0,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
0x20,  0x21,  0x22,  0x23,	0x24,  0x25,  0x26,  0x27,
0x28,  0x29,  0x2a,  0x2b,	0x2c,  0x2d,  0x2e,  0x2f,
0x30,  0x31,  0x32,  0x33,	0x34,  0x35,  0x36,  0x37,
0x38,  0x39,  0x3a,  0x3b,	0x3c,  0x3d,  0x3e,  0x3f,
0x40,  0x41,  0x42,  0x43,	0x44,  0x45,  0x46,  0x47,
0x48,  0x49,  0x4a,  0x4b,	0x4c,  0x4d,  0x4e,  0x4f,
0x50,  0x51,  0x52,  0x53,	0x54,  0x55,  0x56,  0x57,
0x58,  0x59,  0x5a,  0x5b,	0x5c,  0x5d,  0x5e,  0x5f,
0xa3,  0x61,  0x62,  0x63,	0x64,  0x65,  0x66,  0x67,
0x68,  0x69,  0x6a,  0x6b,	0x6c,  0x6d,  0x6e,  0x6f,
0x70,  0x71,  0x72,  0x73,	0x74,  0x75,  0x76,  0x77,
0x78,  0x79,  0x7a,  0x7b,	0x7c,  0x7d,  0x7e,  0xa9,
0xe4,  0xe3,  0xe5,  0xe9,	0xf6,  0xf5,  0xf8,  0xfc,
0xe7,  0xf1,  0xe6,  0x153, 0xe1,  0xe0,  0xe2,  0xeb,
0xe8,  0xea,  0xef,  0xed,	0xec,  0xee,  0xf3,  0xf2,
0xf4,  0xfa,  0xf9,  0xfb,	0xdf,  0xa2,  0xa5,  0x60,
0xc4,  0xc3,  0xc5,  0xc9,	0xd6,  0xd5,  0xd8,  0xdc,

0xc7,  0xd1,  0xc6,  0x152, 0x3b1, 0x3b4, 0x3b8, 0x393,
0x3bc, 0x3c0, 0x3c6, 0xa1,	0xbf,  0xb6,  0xa7,  0xa4,
0xab,  0xbb,  0xb0,  0xf7,	0x2190,0x2192,0x2191,0x2193,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1,
1,	   1,	  1,	 1, 	1,	   1,	  1,	 1
};

/* table with values, .notdef has to be the smallest value (1), last element
   has code zero. */
static const CharName charnames[]= {
		{1,".notdef"},
	/* ASCII */
		{0x20,"space"},
		{0x21,"exclam"},
		{0x22,"quotedbl"},
		{0x23,"numbersign"},
		{0x24,"dollar"},
		{0x25,"percent"},
		{0x26,"ampersand"},
		{0x27,"quotesingle"},
		{0x28,"parenleft"},
		{0x29,"parenright"},
		{0x2a,"asterisk"},
		{0x2b,"plus"},
		{0x2c,"comma"},
		{0x2d,"hyphen"},
		{0x2e,"period"},
		{0x2f,"slash"},
		{0x30,"zero"},{0x31,"one"},{0x32,"two"},  {0x33,"three"},{0x34,"four"},
		{0x35,"five"},{0x36,"six"},{0x37,"seven"},{0x38,"eight"},{0x39,"nine"},
		{0x3a,"colon"},
		{0x3b,"semicolon"},
		{0x3c,"less"},
		{0x3d,"equal"},
		{0x3e,"greater"},
		{0x3f,"question"},
		{0x40,"at"},
		{0x41,"A"}, {0x42,"B"}, {0x43,"C"}, {0x44,"D"}, {0x45,"E"}, {0x46,"F"},
		{0x47,"G"}, {0x48,"H"}, {0x49,"I"}, {0x4a,"J"}, {0x4b,"K"}, {0x4c,"L"},
		{0x4d,"M"}, {0x4e,"N"}, {0x4f,"O"}, {0x50,"P"}, {0x51,"Q"}, {0x52,"R"},
		{0x53,"S"}, {0x54,"T"}, {0x55,"U"}, {0x56,"V"}, {0x57,"W"}, {0x58,"X"},
		{0x59,"Y"}, {0x5a,"Z"},
		{0x5b,"bracketleft"},
		{0x5c,"backslash"},
		{0x5d,"bracketright"},
		{0x5e,"asciicircum"},
		{0x5f,"underscore"},
		{0x60,"grave"},
		{0x61,"a"}, {0x62,"b"}, {0x63,"c"}, {0x64,"d"}, {0x65,"e"}, {0x66,"f"},
		{0x67,"g"}, {0x68,"h"}, {0x69,"i"}, {0x6a,"j"}, {0x6b,"k"}, {0x6c,"l"},
		{0x6d,"m"}, {0x6e,"n"}, {0x6f,"o"}, {0x70,"p"}, {0x71,"q"}, {0x72,"r"},
		{0x73,"s"}, {0x74,"t"}, {0x75,"u"}, {0x76,"v"}, {0x77,"w"}, {0x78,"x"},
		{0x79,"y"}, {0x7a,"z"},
		{0x7b,"braceleft"},
		{0x7c,"bar"},
		{0x7d,"braceright"},
		{0x7e,"asciitilde"},
	/* latin1 */
		{0xa0,"nbspace"},
		{0xa1,"exclamdown"},
		{0xa2,"cent"},
		{0xa3,"sterling"},
		{0xa4,"currency"},
		{0xa5,"yen"},
		{0xa6,"brokenbar"},
		{0xa7,"section"},
		{0xa8,"dieresis"},
		{0xa9,"copyright"},
		{0xaa,"ordfeminine"},
		{0xab,"guillemotleft"},
		{0xac,"logicalnot"},
		{0xad,"sfthyphen"},
		{0xae,"registered"},
		{0xaf,"overstore"},
		{0xb0,"degree"},
		{0xb1,"plusminus"},
		{0xb2,"twosuperior"},
		{0xb3,"threesuperior"},
		{0xb4,"acute"},
		{0xb6,"paragraph"},
		{0xb7,"middot"},
		{0xb8,"cedilla"},
		{0xb9,"onesuperior"},
		{0xba,"ordmasculine"},
		{0xbb,"guillemotright"},
		{0xbc,"onequarter"},
		{0xbd,"onehalf"},
		{0xbe,"threequarters"},
		{0xbf,"questiondown"},
		{0xc0,"Agrave"},
		{0xc1,"Aacute"},
		{0xc2,"Acircumflex"},
		{0xc3,"Atilde"},
		{0xc4,"Adieresis"},
		{0xc5,"Aring"},
		{0xc6,"AE"},
		{0xc7,"Ccedilla"},
		{0xc8,"Egrave"},
		{0xc9,"Eacute"},
		{0xca,"Ecircumflex"},
		{0xcb,"Edieresis"},
		{0xcc,"Igrave"},
		{0xcd,"Iacute"},
		{0xce,"Icircumflex"},
		{0xcf,"Idieresis"},
		{0xd0,"Eth"},
		{0xd1,"Ntilde"},
		{0xd2,"Ograve"},
		{0xd3,"Oacute"},
		{0xd4,"Ocircumflex"},
		{0xd5,"Otilde"},
		{0xd6,"Odieresis"},
		{0xd7,"multiply"},
		{0xd8,"Oslash"},
		{0xd9,"Ugrave"},
		{0xda,"Uacute"},
		{0xdb,"Ucircumflex"},
		{0xdc,"Udieresis"},
		{0xdd,"Yacute"},
		{0xde,"Thorn"},
		{0xdf,"germandbls"},
		{0xe0,"agrave"},
		{0xe1,"aacute"},
		{0xe2,"acircumflex"},
		{0xe3,"atilde"},
		{0xe4,"adieresis"},
		{0xe5,"aring"},
		{0xe6,"ae"},
		{0xe7,"ccedilla"},
		{0xe8,"egrave"},
		{0xe9,"eacute"},
		{0xea,"ecircumflex"},
		{0xeb,"edieresis"},
		{0xec,"igrave"},
		{0xed,"iacute"},
		{0xee,"icircumflex"},
		{0xef,"idieresis"},
		{0xf0,"eth"},
		{0xf1,"ntilde"},
		{0xf2,"ograve"},
		{0xf3,"oacute"},
		{0xf4,"ocircumflex"},
		{0xf5,"otilde"},
		{0xf6,"odieresis"},
		{0xf7,"divide"},
		{0xf8,"oslash"},
		{0xf9,"ugrave"},
		{0xfa,"uacute"},
		{0xfb,"ucircumflex"},
		{0xfc,"udieresis"},
		{0xfd,"yacute"},
		{0xfe,"thorn"},
		{0xff,"ydieresis"},
	/* european latin */
		{0x102,"Abreve"},
		{0x103,"abreve"},
		{0x104,"Aogonek"},
		{0x105,"aogonek"},
		{0x106,"Cacute"},
		{0x107,"cacute"},
		{0x10c,"Ccaron"},
		{0x10d,"ccaron"},
		{0x10e,"Dcaron"},
		{0x10f,"dcaron"},
		{0x110,"Dslash"},
		{0x111,"dmacron"},
		{0x118,"Eogonek"},
		{0x119,"eogonek"},
		{0x11a,"Ecaron"},
		{0x11b,"ecaron"},
		{0x11e,"Gbreve"},
		{0x11f,"gbreve"},
		{0x130,"Idot"},
		{0x131,"dotlessi"},
		{0x139,"Lacute"},
		{0x13a,"lacute"},
		{0x13d,"Lcaron"},
		{0x13e,"lcaron"},
		{0x13f,"Ldot"},
		{0x140,"ldot"},
		{0x141,"Lslash"},
		{0x142,"lslash"},
		{0x143,"Nacute"},
		{0x144,"nacute"},
		{0x147,"Ncaron"},
		{0x148,"ncaron"},
		{0x150,"Odblacute"},
		{0x151,"odblacute"},
		{0x152,"OE"},
		{0x153,"oe"},
		{0x154,"Racute"},
		{0x155,"racute"},
		{0x158,"Rcaron"},
		{0x159,"rcaron"},
		{0x15a,"Sacute"},
		{0x15b,"sracute"},
		{0x15e,"Scedilla"},
		{0x15f,"scedilla"},
		{0x160,"Scaron"},
		{0x161,"scaron"},
		{0x162,"Tcedilla"},
		{0x163,"tcedilla"},
		{0x164,"Tcaron"},
		{0x165,"tcaron"},
		{0x16e,"Uring"},
		{0x16f,"uring"},
		{0x170,"Udblacute"},
		{0x171,"udblacute"},
		{0x178,"Ydieresis"},
		{0x179,"Zacute"},
		{0x17a,"zacute"},
		{0x17d,"Zcaron"},
		{0x17e,"zcaron"},
		{0x17b,"Zdot"},
		{0x17c,"zdot"},
	/* extended latin */
		{0x192,"florin"},
	/* unassigned -- used in PROforma for big brackets and braces */
		{0x0200,"parenlefttp"},
		{0x0201,"parenleftex"},
		{0x0202,"parenleftbt"},
		{0x0203,"bracketlefttp"},
		{0x0204,"bracketleftex"},
		{0x0205,"bracketleftbt"},
		{0x0206,"bracelefttp"},
		{0x0207,"braceleftmid"},
		{0x0208,"braceleftbt"},
		{0x0209,"parenrighttp"},
		{0x020a,"parenrightex"},
		{0x020b,"parenrightbt"},
		{0x020c,"bracketrighttp"},
		{0x020d,"bracketrightex"},
		{0x020e,"bracketrightbt"},
		{0x020f,"bracerighttp"},
		{0x0210,"bracerightmid"},
		{0x0211,"bracerightbt"},
		{0x2012,"braceex"},
	/* standard phonetic */
	/* modifier letters */
		{0x02c6,"circumflex"},
		{0x02c7,"caron"},
		{0x02c9,"macron"},
		{0x02d8,"breve"},
		{0x02d9,"dotaccent"},
		{0x02da,"ring"},
		{0x02db,"ogonek"},
		{0x02dc,"tilde"},
		{0x02dd,"hungarumlaut"},
	/* generic diacritical marks */
	/* greek */
		{0x0391,"Alpha"},
		{0x0392,"Beta"},
		{0x0393,"Gamma"},
		{0x0394,"Delta"},
		{0x0395,"Epsilon"},
		{0x0396,"Zeta"},
		{0x0397,"Eta"},
		{0x0398,"Theta"},
		{0x0399,"Iota"},
		{0x039a,"Kappa"},
		{0x039b,"Lambda"},
		{0x039c,"Mu"},
		{0x039d,"Nu"},
		{0x039e,"Xi"},
		{0x039f,"Omicron"},
		{0x03a0,"Pi"},
		{0x03a1,"Rho"},
		{0x03a3,"Sigma"},
		{0x03a4,"Tau"},
		{0x03a5,"Upsilon"},
		{0x03a6,"Phi"},
		{0x03a7,"Chi"},
		{0x03a8,"Psi"},
		{0x03a9,"Omega"},
		{0x03ab,"Upsilon1"},
		{0x03b1,"alpha"},
		{0x03b2,"beta"},
		{0x03b3,"gamma"},
		{0x03b4,"delta"},
		{0x03b5,"epsilon"},
		{0x03b6,"zeta"},
		{0x03b7,"eta"},
		{0x03b8,"theta"},
		{0x03b9,"iota"},
		{0x03ba,"kappa"},
		{0x03bb,"lambda"},
		{0x03bc,"mu"},
		{0x03bd,"nu"},
		{0x03be,"xi"},
		{0x03bf,"omicron"},
		{0x03c0,"pi"},
		{0x03c1,"rho"},
		{0x03c2,"sigma1"},
		{0x03c3,"sigma"},
		{0x03c4,"tau"},
		{0x03c5,"upsilon"},
		{0x03c6,"phi"},
		{0x03c7,"chi"},
		{0x03c8,"psi"},
		{0x03c9,"omega"},
		{0x03d1,"theta1"},
		{0x03d5,"phi1"},
		{0x03d6,"omega1"},
	/* cyrillic */
	/* armenian */
	/* hebrew */
		{0x05d0,"aleph"},
	/* general punctiation */
		{0x2013,"endash"},
		{0x2014,"emdash"},
		{0x2017,"underscoredbl"},
		{0x2018,"quoteleft"},
		{0x2019,"quoteright"},
		{0x201a,"quotesinglbase"},
		{0x201c,"quotedblleft"},
		{0x201d,"quotedblright"},
		{0x201e,"quotedblbase"},
		{0x2020,"dagger"},
		{0x2021,"daggerdbl"},
		{0x2022,"bullet"},
		{0x2024,"periodcentered"},
		{0x2026,"ellipsis"},
		{0x2030,"perthousand"},
		{0x2031,"pertenthousand"},
		{0x2039,"guilsinglleft"},
		{0x203a,"guilsinglright"},
		{0x203c,"exclamdbl"},
	/* sups & subs */
		{0x207f,"nsuperior"},
	/* currency */
		{0x20a3,"franc"},
		{0x20a7,"peseta"},
	/* diacritics */
	/* letterlike symbols */
		{0x2102,"complex"},
		{0x2103,"Celsius"},
		{0x2109,"Fahrenheit"},
		{0x2111,"Ifraktur"},
		{0x2115,"natural"},
		{0x2118,"weierstrass"},
		{0x211c,"Rfraktur"},
		{0x211d,"real"},
		{0x2122,"trademark"},
		{0x2124,"integer"},
		{0x2126,"ohm"},
	/* number forms */
	/* arrows */
		{0x2190,"arrowleft"},
		{0x2191,"arrowup"},
		{0x2192,"arrowright"},
		{0x2193,"arrowdown"},
		{0x2194,"arrowboth"},
		{0x2195,"arrowupdn"},
		{0x2196,"arrowupleft"},
		{0x2197,"arrowupright"},
		{0x2198,"arrowdownright"},
		{0x2199,"arrowdownleft"},
		{0x21a8,"arrowupdnbse"},
		{0x21d0,"arrowdblleft"},
		{0x21d1,"arrowdblup"},
		{0x21d2,"arrowdblright"},
		{0x21d3,"arrowdbldown"},
		{0x21d4,"arrowdblboth"},
		{0x21d5,"arrowdblupdn"},
		{0x21d6,"arrowdblupleft"},
		{0x21d7,"arrowdblupright"},
		{0x21d8,"arrowdbldownright"},
		{0x21d9,"arrowdbldownleft"},
	/* anassigned -- used in PROforma for extensions to arrows */
		{0x21f0,"arrowhorizex"},
		{0x21f1,"arrowvertex"},
		{0x21f2,"arrowdblhorizex"},
		{0x21f3,"arrowdblvertex"},
	/* mathematical operators */
		{0x2200,"universal"},
		{0x2201,"complement"},
		{0x2202,"partialdiff"},
		{0x2203,"existential"},
		{0x2204,"notexists"},
		{0x2205,"emptyset"},
		{0x2207,"gradient"},
		{0x2208,"element"},
		{0x2209,"notelement"},
		{0x220d,"suchthat"},
		{0x220f,"product"},
		{0x2211,"summation"},
		{0x2212,"minus"},
		{0x2215,"fraction"},
		{0x2217,"asteriskmath"},
		{0x2219,"dotmath"},
		{0x221a,"radical"},
		{0x221d,"proportional"},
		{0x221e,"infinity"},
		{0x221f,"orthogonal"},
		{0x2220,"angle"},
		{0x2227,"logicaland"},
		{0x2228,"logicalor"},
		{0x2229,"intersection"},
		{0x222a,"union"},
		{0x222b,"integral"},
		{0x2234,"therefore"},
		{0x223c,"similar"},
		{0x2245,"congruent"},
		{0x2248,"approxequal"},
		{0x2260,"notequal"},
		{0x2261,"equivalence"},
		{0x2264,"lessequal"},
		{0x2265,"greaterequal"},
		{0x2282,"propersubset"},
		{0x2283,"propersuperset"},
		{0x2284,"notsubset"},
		{0x2285,"notsuperset"},
		{0x2286,"reflexsubset"},
		{0x2287,"reflexsuperset"},
		{0x2288,"notreflexsubset"},
		{0x2289,"notreflexsuperset"},
		{0x22a5,"perpendicular"},
	/* unassigned -- used in PROforma for extensions to math */
		{0x22f2,"radicalex"},
		{0x22f3,"minute"},
		{0x22f4,"second"},
		{0x22f5,"angleleft"},
		{0x22f6,"angleright"},
		{0x22f7,"circleplus"},
		{0x22f8,"circlemin"},
		{0x22f9,"circlemultiply"},
		{0x22fa,"circledivide"},
	/* miscellaneous technical */
		{0x2302,"house"},
		{0x2310,"revlogicalnot"},
		{0x2320,"integraltp"},
		{0x2321,"integralbt"},
	/* unassigned -- used in PROforma for extenions to miscellaneous technical */
		{0x2330,"integralex"},
		{0x2331,"carriagereturn"},
		{0x2332,"registerserif"},
		{0x2333,"copyrightserif"},
		{0x2334,"trademarkserif"},
		{0x2335,"registersans"},
		{0x2336,"copyrightsans"},
		{0x2337,"trademarksans"},
	/* control pictures */
	/* enclosed alphanumerics */
	/* form & chart components */
	/* blocks */
		{0x2580,"upblock"},{0x2584,"dnblock"},{0x2588,"block"},{0x258c,"lfblock"},
		{0x2590,"rtblock"},{0x2591,"ltshade"},{0x2592,"shade"},{0x2593,"dkshade"},
	/* geometric shapes */
		{0x25a0,"filledbox"},{0x25ac,"filledrect"},{0x25b2,"triagup"},
		{0x25ba,"triagrt"},{0x25bc,"triagdn"},{0x25c4,"triaglf"},{0x25ca,"lozenge"},
		{0x25cb,"circle"},{0x25d8,"invbullet"},{0x25d9,"invcircle"},
	/* miscelaneous dingbats */
		{0x263a,"smileface"},{0x263b,"invsmileface"},{0x263c,"sun"},
		{0x2640,"female"},{0x2642,"male"},{0x2660,"spade"},{0x2663,"club"},
		{0x2665,"heart"},{0x2666,"diamond"},{0x266a,"musicalnote"},
		{0x266b,"musicalnotedbl"},
	/* unassigned - used in PROforma for extenions like ligatures etc */
		{(short)0xf000,"apple"},
		{(short)0xf001,"fi"},
		{(short)0xf002,"fl"},
		{(short)0xf003,"ff"},
		{(short)0xf004,"ffi"},
		{(short)0xf005,"ffl"},
		{'\\',""},{0,""}
	};

static short readshort(char *p, char **ret)
{
	int number;
	char neg=FALSE;

	if(*p=='-') { neg=TRUE; p++; }
	number=(*p++)-'0';
	while(*p>='0' && *p<='9') number=number*10+((*p++)-'0');
	if (neg) number=-number;

	if (*p=='\\')
	{
		*ret=++p;
		return number;
	}
	else
		return ASCII2unicode['\\'];
}

static int matchname(char *t, CharName *name, char **ret)
{
	char *word=name->name;
	if (*t=='\\')
	{
		*ret=t+1;
		return ASCII2unicode['\\'];
	}
	while (*word) if (*word++!=*t++) return 0;
	if (*t!='\\') return 0;
	*ret=t+1;
	return name->code;
}


int PFChar2UniCode(Gstate gstate, char *n, char **ret)
{
	/* routine to get the unicode of the first glyph in a string, and
	   increase the base of the string.
	   If the string starts with '\', then the following characters build
	   the glyphs according to the glyph name, or a decimal number (the
	   unicode). If the part after the '\' is not recognised, then just
	   the '\' is printed. The '\' can be included by typing '\\' */
	short code;
	CharName *el=charnames;

	*ret=n+1;
	if (*n!='\\' || gstate->printescape)
		return ASCII2unicode[*(unsigned char *)n];
	else
	{
		n++;
		if (*n>='0' && *n<='9')
			return readshort(n,ret);
		while (TRUE)
		{
			if (code=matchname(n,el,ret)) return code;
			if (!el->code)
			{
				*ret=n;
				return ASCII2unicode[(unsigned char)'\\'];
			}
			el++;
		}
	}
}

short *PFASCII2UnicodeTable=ASCII2unicode;
CharName *PFCharNameTable=charnames;
