/*
	PROforma, PROgs FOnt & Raster MAnager

	special driver which is used to draw the font cache

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 23 March 1994
	06.03.1995 for better results at small sizes. Make sure a horizontal span
			   of less than a pixel is still represented by a pixel.
	07.03.1995 yesterdays adjustments created the pixel shifted .5 to the
			   right, fixed
	25.11.1996 special version to fix small vertical spans added
	30.11.1996 now only routines to draw lines in cache
*/

#include <sms.h>
#include <err.h>

#include "gstate.h"
#include "system.h"

/* draw a horizontal line on the bitmap */
Error CacheHorizontal(Mask *mask, short y, short xs, short xe)
{
	unsigned char *base=mask->base; /* base of bitmap */
	char xl, xr;					/* bit pattern for x */
	short dist; 					/* number of pixels to fill */

	dist=xe-xs; if (dist<=0) return ERR_OK;

	xl=0xff >> (xs&7);				/* mask for pixels at left */
	xr=~(0xff >> (xe&7));			/* mask for pixels at right */
	base+=y*mask->linc+(xs/8);		/* address in bitmap to set pixels */

	dist-=8-(xs&7); 				/* calculate number of pixels to go */
									/* after first byte */
	if (dist<0) 					/* only one byte to adjust */
	{
		xl&=xr;
		*base|=xl;
	} else {                        /* adjust at least two bytes */
		*base++|=xl;
		for (dist>>=3; dist; dist--) *base++=0xff;
		*base|=xr;
	}
	return ERR_OK;
}

/* draw a pixel on the bitmap */
Error CacheVertical(Mask *mask, short x, short y, short ye)
{
	if (ye==y+1)
		*(mask->base+y*mask->linc+(x/8))|=0x80 >> (x&7);
	return ERR_OK;
}
